﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.IO;

namespace Lerak
{
    public static class Communicator
    {
        public static int CharToConst( char c )
        {
            switch (Char.ToLower(c))
            {
                case 'x':
                    {
                        return Game.WALL;
                    }
                case '#':
                    {
                        return Game.HOLE;
                    }
                case '.':
                    {
                        return Game.NOTHING;
                    }
                case '^':
                    {
                        return Game.TRACK_UP;
                    }
                case 'v':
                    {
                        return Game.TRACK_DOWN;
                    }
                case '>':
                    {
                        return Game.TRACK_RIGHT;
                    }
                case '<':
                    {
                        return Game.TRACK_LEFT;
                    }
                case '$':
                    {
                        return Game.GOAL;
                    }
                default:
                    {
                        return 0;
                    }
            }
        }
        public static Game SendRequest(string request)
        {
            WebRequest req = WebRequest.Create(string.Format("http://{0}/{1}", Settings.serverAddress, request));
            req.Method = "GET";
            WebResponse res = req.GetResponse();
            StreamReader sr = new StreamReader(res.GetResponseStream());
            string radek = sr.ReadLine();
            if ((radek.ToLower().Contains("vyhrali")) || (radek.ToLower().Contains("chyba")))
            {
                Game g = new Game();
                g.ServerMessage = radek;
                sr.Close();
                res.Close();
                return g;
            }
            else
            {
                Game g = new Game();
                g.ServerMessage = null;
                int id = 0;
                g.ID = int.TryParse(radek.Trim(), out id) ? id : 0;
                for (int j = 1; j <= 20; j++)
                {
                    radek = sr.ReadLine();
                    for (int i = 1; i <= 20; i++)
                    {
                        g.Map[i, j] = CharToConst(radek[i-1]);
                    }                    
                }
                radek = sr.ReadLine();
                string[] data = radek.Split(' ');
                g.LerakPos.X = int.Parse(data[0]);
                g.LerakPos.Y = int.Parse(data[1]);
                switch (data[2].Trim().ToLower())
                {
                    case "n":
                        {
                            g.LerakDir = Direction.Up;
                            break;
                        }
                    case "r":
                        {
                            g.LerakDir = Direction.Right;
                            break;
                        }
                    case "d":
                        {
                            g.LerakDir = Direction.Down;
                            break;
                        }
                    case "l":
                        {
                            g.LerakDir = Direction.Left;
                            break;
                        }
                }
                radek = sr.ReadLine();
                radek = radek.ToLower();
                for (int i = 0; i < 9; i++)
                {
                    switch (radek[i])
                    {
                        case '1':
                            {
                                g.Possible[(int)Moves.One]++;
                                break;
                            }
                        case '2':
                            {
                                g.Possible[(int)Moves.Two]++;
                                break;
                            }
                        case '3':
                            {
                                g.Possible[(int)Moves.Three]++;
                                break;
                            }
                        case 'z':
                            {
                                g.Possible[(int)Moves.Back]++;
                                break;
                            }
                        case 'l':
                            {
                                g.Possible[(int)Moves.Left]++;
                                break;
                            }
                        case 'r':
                            {
                                g.Possible[(int)Moves.Right]++;
                                break;
                            }
                    }
                }
                g.SetDefaultLerak();
                g.SetDefaultPossible();
                sr.Close();
                res.Close();
                return g;
            }
        }
    }
}
