﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Lerak
{
    public partial class UserGame : Form
    {
        const int SIZE = 30;
        public UserGame()
        {
            InitializeComponent();
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {

        }

        private void btnMove_Click(object sender, EventArgs e)
        {

        }

        Game g = null;

        private void SetMoveButtons()
        {
            Button btn = null;
            for (int i = 0; i < 6; i++)
            {
                btn = ( Button )this.Controls["btn" + i.ToString()];
                SetNumberButtonText(btn, g.Possible[i]);
            }
        }

        private void StartNewGame()
        {
            g = Communicator.SendRequest("start");
            SetMoveButtons();
            tbChosenMoves.Text = "";
            DrawBoard();
        }


        private void UserGame_Load(object sender, EventArgs e)
        {
          
        }

        private void DrawBoard()
        {
            Graphics gr = pbBoard.CreateGraphics();
            
            for (int j = 1; j <= 20; j++)
            {
                for (int i = 1; i <= 20; i++)
                {
                    //vykresli políčko
                    gr.DrawRectangle(Pens.Black, (i - 1) * SIZE, (j - 1) * SIZE, SIZE, SIZE);
                    switch (g.Map[i, j])
                    {
                        case Game.HOLE:
                            {
                                gr.DrawLine(new Pen(Color.Red, 2.0f), (i - 1) * SIZE, (j - 1) * SIZE, (i) * SIZE, (j) * SIZE);
                                gr.DrawLine(new Pen(Color.Red, 2.0f), (i - 1) * SIZE, (j) * SIZE, (i) * SIZE, (j-1) * SIZE);
                                break;
                            }
                        case Game.GOAL:
                            {
                                gr.FillRectangle(Brushes.Gold, (i - 1) * SIZE+1, (j - 1) * SIZE+1, SIZE-1, SIZE-1);
                                gr.DrawString("$", new Font("Arial", 13f), Brushes.Red, (i - 1) * SIZE + 10, (j - 1) * SIZE + 8);
                                break;
                            }
                        case Game.TRACK_DOWN:
                            {
                                gr.FillRectangle(Brushes.LightBlue, (i - 1) * SIZE + 1, (j - 1) * SIZE + 1, SIZE - 1, SIZE - 1);
                                gr.DrawString("▼", new Font("Arial", 10f), Brushes.Red, (i - 1) * SIZE + 10, (j - 1) * SIZE + 8);
                                break;
                            }
                        case Game.TRACK_LEFT:
                            {
                                gr.FillRectangle(Brushes.LightBlue, (i - 1) * SIZE + 1, (j - 1) * SIZE + 1, SIZE - 1, SIZE - 1);
                                gr.DrawString("◄", new Font("Arial", 10f), Brushes.Red, (i - 1) * SIZE + 10, (j - 1) * SIZE + 8);
                                break;
                            }
                        case Game.TRACK_RIGHT:
                            {
                                gr.FillRectangle(Brushes.LightBlue, (i - 1) * SIZE + 1, (j - 1) * SIZE + 1, SIZE - 1, SIZE - 1);
                                gr.DrawString("►", new Font("Arial", 10f), Brushes.Red, (i - 1) * SIZE + 10, (j - 1) * SIZE + 8);
                                break;
                            }
                        case Game.TRACK_UP:
                            {
                                gr.FillRectangle(Brushes.LightBlue, (i - 1) * SIZE + 1, (j - 1) * SIZE + 1, SIZE - 1, SIZE - 1);
                                gr.DrawString("▲", new Font("Arial", 10f), Brushes.Red, (i - 1) * SIZE + 10, (j - 1) * SIZE + 8);
                                break;
                            }
                        case Game.WALL:
                            {
                                gr.FillRectangle(Brushes.Brown, (i - 1) * SIZE + 1, (j - 1) * SIZE + 1, SIZE - 1, SIZE - 1);                                
                                break;
                            }
                        case Game.NOTHING:
                            {
                                gr.FillRectangle(Brushes.White, (i - 1) * SIZE + 1, (j - 1) * SIZE + 1, SIZE - 1, SIZE - 1);
                                break;
                            }
                    }
                }
            }
            //vrátí Leraka na původní pozici
            g.ResetLerak();
            //vykresli pozici LERAKA
            char dir = Game.DirToChar(g.LerakDir);            
            gr.DrawString(dir.ToString(), new Font( "Arial", 10f, FontStyle.Bold), Brushes.Black, (g.LerakPos.X - 1) * SIZE + 2, (g.LerakPos.Y - 1) * SIZE+15 );
            /*//vykresli aktuální pohyb
            bool redraw = false;
            if (tbChosenMoves.Text.Length > 0)
            {
                for (int i = 0; i < tbChosenMoves.Text.Length; i++)
                {
                    if (g.MakeMove(Game.CharToMoveID(tbChosenMoves.Text[i])))
                    {
                        gr.FillEllipse(Brushes.White, (g.LerakPos.X - 1) * SIZE + 1, (g.LerakPos.Y - 1) * SIZE + 1, 10, 10);
                        gr.DrawEllipse(Pens.Black, (g.LerakPos.X - 1) * SIZE + 1, (g.LerakPos.Y - 1) * SIZE + 1, 10, 10);
                        gr.DrawString((i + 1).ToString(), new Font("Arial", 8f), Brushes.Black, (g.LerakPos.X - 1) * SIZE + 2, (g.LerakPos.Y - 1) * SIZE + 2);
                    }
                    else
                    {
                        MessageBox.Show("Tyto pohyby by vedly ke zničení Leraka.");
                        g.ResetLerak();
                        g.ResetPossible();
                        SetMoveButtons();
                        tbChosenMoves.Text = "";
                        redraw = true;
                        break;
                    }
                }
            }
            if ( redraw )
            {
                gr.Dispose();
                DrawBoard();
            }
            else {
                gr.Dispose();
            }*/
            gr.Dispose();
        }

        private void tbChosenMoves_TextChanged(object sender, EventArgs e)
        {
            
        }

        /// <summary>
        /// Nastavuje tlačítku s čísly nový popisek
        /// </summary>
        /// <param name="b"></param>
        /// <param name="number"></param>
        private void SetNumberButtonText(Button b, int number)
        {
            //rozdělíme si text tlačítka na popisek a počet
            string[] texts = b.Text.Split(' ');
            ///nastavíme nový kompletní popisek
            b.Text = String.Format("{0} ({1})", texts[0], number);
        }

        private void btnNumber_Click(object sender, EventArgs e)
        {
            //není již vybráno pět pohybů?
            if (tbChosenMoves.Text.Length < 5)
            {
                //Jaké tlačítko bylo stisknuto?
                Button b = (Button)sender;
                int moveID = int.Parse(b.Tag.ToString());
                //Snížíme jeho dostupný počet, pokud není 0
                if (g.Possible[moveID] > 0)
                {
                    g.Possible[moveID]--;
                    //Nastavíme text tlačítka
                    SetNumberButtonText(b, g.Possible[moveID]);
                    //Přidáme pohyb do seznamu (část před závorkou)
                    tbChosenMoves.Text += b.Text.Split(' ')[0];
                }
                DrawBoard();
            }
        }

        private void btnBackspace_Click(object sender, EventArgs e)
        {
            //pokud je co mazat
            if (tbChosenMoves.Text.Length > 0)
            {
                string actmoves = tbChosenMoves.Text;
                //zjistíme jaký pohyb reprezentuje poslední znak v textovém poli
                int moveID = Game.CharToMoveID(actmoves[actmoves.Length - 1]);
                //odstraní poslední z textu
                actmoves = actmoves.Remove(actmoves.Length - 1);
                //nasstaví nový text
                tbChosenMoves.Text = actmoves;
                //zvýšíme jeho dostupné množství
                g.Possible[moveID]++;
                //opravíme popisek odpovídajícího tlačítka
                SetNumberButtonText((Button)this.Controls["btn" + moveID.ToString()], g.Possible[moveID]);
                //překreslíme plochu
                DrawBoard();
            }
        }

        private void btn0_Click(object sender, EventArgs e)
        {

        }

        private void UserGame_Shown(object sender, EventArgs e)
        {
            StartNewGame();  
        }

        private void pbBoard_Paint(object sender, PaintEventArgs e)
        {
            DrawBoard();
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            if (tbChosenMoves.Text.Trim().Length != 0)
            {
                //pošli požadavek
                Game res = Communicator.SendRequest(string.Format("kolo?id={0}&pohyby={1}", g.ID, tbChosenMoves.Text.Trim().ToUpper()));
                if (res.ServerMessage != null)
                {
                    //zobraz zprávu ze serveru
                    MessageBox.Show(res.ServerMessage);
                    // hra skončila, spouštíme novou hru
                    StartNewGame();
                }
                else
                {
                    g = res;
                    SetMoveButtons();
                    tbChosenMoves.Text = "";
                    DrawBoard();
                }
            }
        }

        private void btnNewGame_Click(object sender, EventArgs e)
        {
            StartNewGame();
        }
    }
}
